stages:
  - testing
  - build
  - publish
  - deploy

variables:
  IMAGE_VERSION: "1.0.0"

build-docker-image:
  stage: build
  tags:
    - gcp_runner
  script:
    - echo $IMAGE_VERSION-build$CI_PIPELINE_IID
    - docker build -t $CI_REGISTRY_IMAGE:$IMAGE_VERSION-build$CI_PIPELINE_IID .
    - docker tag $CI_REGISTRY_IMAGE:$IMAGE_VERSION-build$CI_PIPELINE_IID $CI_REGISTRY_IMAGE:latest
    - docker images

push-to-registry:
  stage: publish
  tags:
    - gcp_runner
  needs:
    - build-docker-image
  before_script:
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
  script:
    - docker push $CI_REGISTRY_IMAGE:$IMAGE_VERSION-build$CI_PIPELINE_IID
    - docker push $CI_REGISTRY_IMAGE:latest

deploy-to-gcp:
  stage: deploy
  needs:
    - push-to-registry
  before_script:
    - eval $(ssh-agent -s)
    - ssh-add <(echo "$GCP_PRIVATE_KEY")
  script:
    - scp -o StrictHostKeyChecking=no ./docker-compose_mylaravel.yml $GCP_USER@$GCP_SERVER:/home/$GCP_USER
    - ssh -o StrictHostKeyChecking=no $GCP_USER@$GCP_SERVER "
        export PORT_LARAVEL=$PORT_LARAVEL && export PORT_PYTHON=$PORT_PYTHON; 
        docker compose -f docker-compose_mylaravel.yml down laravel &&
        docker compose -f docker-compose_mylaravel.yml up -d
        "
  environment:
    name: $CI_PROJECT_NAME
    url: http://$APP_HOSTNAME:$PORT_LARAVEL/
